;-- AVL / ABE167 - Terminal-Test (Tests fuer ein Anzeigeterminal mit CANopen) ----
; Autor: Wolfgang Buescher     Stand: 2004-06-17
;   Ablage des Originals: <WoBu2>C:\Programme\CanTestW\Programs\AVL_ABE167_Test.txt .
;   Mit Test der Funktionalitaet der Firmware nach DS301 V4.0 (!!!)
; AUCH fuer andere Geraete mit "DS 301  V4.0" geeignet, z.B. Terminals, E/A-Module .
; 

;-- Einstellung Variablen ---------------------------------------------------
@print N,J,P,S,T,Y,L  ; Test: press F2 with cursor in this line to check settings !
@N=1       ; Node-ID (==DIP-Schalter-Adresse, beim Terminal: Systemmenue)
@J=384+N   ; Identifier f. PDO EA->Master (Inputs,Lenze: 767+N, DS401:384+N)
@P=512+N   ; Identifier f. PDO Master->EA (Outputs,Lenze: 768+N, DS401:512+N)
@S=1536+N  ; SDO(rx) des E/A-Master-Moduls
@T=1408+N  ; SDO(tx) des E/A-Master-Moduls (!)
@Y= 1      ; Option: 0=ohne SYNC  1=mit SYNC
@L= 1      ; Option: 0=Laufl.aus  1=Laufl.an
@sdo.node(N)    ; Node-ID fuer SDO-Zugriffe mit sdo.read() und sdo.write()
@print "NODE-ID fuer SDO-Zugriffe = %ld", sdo.node

@set_scope.timing 20
@set_scope(5).range 19800 20200
@set_scope(5).range -32768 32767

;@goto LaufLicht

;----- Communication Profile (DS301 V4) -------------------
@print ""
@print "------ Reading Communication Profile .. ------"
@print "DevType=$%08lX",sdo.r($1000.0)
@print "ErrorReg=$%08lX",sdo.r($1001.0)
;@print "ManufStatusReg=$%08lX",sdo.r($1002.0)     ; nicht implementiert
@print "PreDefErrorFld=$%08lX",sdo.r($1003.0)
;@print "NumberOftotalPDOs=$%08lX",sdo.r($1004.0)  ; Objekt 0x1004 hat man in DS301 V4 ...
;@print "NumberOfsynchPDOs=$%08lX",sdo.r($1004.1)  ; ... schlicht und einfach RAUSGESCHMISSEN !
;@print "NumberOfasyncPDOs=$%08lX",sdo.r($1004.2)
@print "CobID_Sync=$%08lX",sdo.r($1005.0)
@print "CommCyclePer=%ld",sdo.r($1006.0)
@print sdo.r($1008.0)   ; device name (as "visible string")
@print sdo.r($1009.0)   ; hardware version ("visible string")
@print sdo.r($100A.0)   ; software version ("visible string")
@print "GuardTime=$%08lX",sdo.r($100C.0)
@print "LifeTimeFactor=$%08lX",sdo.r($100D.0)
;@print "CobIdTimestamp=$%08lX",sdo.r($1012.0)    ; not projected
@print "CobIdEmergency=$%08lX",sdo.r($1014.0)
@print "EmgcyInhibitTi=$%08lX",sdo.r($1015.0)
@print "ProducerHeartb=$%08lX",sdo.r($1017.0)
@print "IdentityObjectSubis=%08lX",sdo.r($1018.0)
@print "RPDO1_CommPar=$%08lX",sdo.r($1400.0) ; highest subindex
@print "RPDO1_CobID=$%08lX",sdo.r($1400.1)
@print "RPDO1_TranType=$%08lX",sdo.r($1400.2)
@print "RPDO1_InhiTime=$%08lX",sdo.r($1400.3)
;@print "RPDO1_CMS_prio=$%08lX",sdo.r($1400.4) ; Obj 0x1400.4 killed by CiA
@print "RPDO1_EvtTimer=$%08lX",sdo.r($1400.5)
@print "RPDO2_CommPar=$%08lX",sdo.r($1401.0)
@print "RPDO2_CobID=$%08lX",sdo.r($1401.1)
@print "RPDO2_TranType=$%08lX",sdo.r($1401.2)
@print "RPDO2_InhiTime=$%08lX",sdo.r($1401.3)
;@print "RPDO2_CMS_prio=$%08lX",sdo.r($1401.4) ; Obj 0x1401.4 killed by CiA
@print "RPDO2_EvtTimer=$%08lX",sdo.r($1401.5)
@print "RPDO3_CobID=$%08lX",sdo.r($1402.1)
@print "TPDO1_CobID=$%08lX",sdo.r($1800.1)
@print "TPDO2_CobID=$%08lX",sdo.r($1801.1)
@print "TPDO3_CobID=$%08lX",sdo.r($1802.1)




@stop   ; STOP READING --- some write accesses follow,
        ; only intended for the software developer
        ; using single-step execution of this command file !

@sdo.w ($1005.0,U32,$40000080) ; configure SYNC-Object
@sdo.w ($1006.0,U32,20000)  ; set comm-cycle to 20000us
@sdo.w($1010.1, U32, 0x65766173) ; "save" ALL PARAMETERS (!)      <<<<<<<
@sdo.w($1011.1, U32, 0x64616F6C) ; "load" DEFAULT PARAMETERS (!)  <<<<<<< ok for CANopen
@sdo.w($1011.1, U32, 0x6C6F6164) ; "load" DEFAULT PARAMETERS (!)  <<<<<<< deliberately WRONG
000 81 00                   ; Node Reset
@print sdo.r($1012.254)     ; Name of this object ?
@print "TimeStampObj=$%08lX",sdo.r($1012.0)
@print sdo.r($1014.254)     ; Name of this object ?
@print "EmergcyObject=$%08lX",sdo.r($1014.0)
@print sdo.r($1015.254)     ; Name of this object ?
@print "EmergencyInhib=%ld",sdo.r($1015.0)
@print sdo.r($1016.254)     ; Name of this object ?
@print "HeartbeatConsumers=%ld",sdo.r($1016.0)
@print "HeartbeatConsumer1=$%08lX",sdo.r($1016.1)
@print "HeartbeatConsumer2=$%08lX",sdo.r($1016.2)
@print sdo.r($1017.254)     ; Name of this object ?
@print "HeartbeatProducerTime=%ld ms",sdo.r($1017.0)
@print sdo.r($1018.254)     ; Name of this object ?
@print "Vendor ID=$%08lX",sdo.r($1018.1) ; MKT=0x004D4B54
@print "Prod.Code=$%08lX",sdo.r($1018.2)
@print "RevisionN=$%08lX",sdo.r($1018.3)
@print "SerialNr.=$%08lX",sdo.r($1018.4)


;-------------- "transmit" - PDO (analoge und digitale Inputs) -------------
   ;
   ; 0x1800 = 1st TPDO Communication parameter
@print "TxPDO1CommPar.Sub0=%ld",sdo.r($1800.0)
@print "TxPDO1CommPar.CobID=$%08lX",sdo.r($1800.1) ; PDO ID of 1st TPDO    ?
@print "TxPDO1CommPar.TrTyp= %03ld",sdo.r($1800.2) ; PDO transmission type ?
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
@sdo.w ($1800.2, U8, 255)                          ; set PDO transmission type
@print "TxPDO1CommPar.Inhib= %05ld",sdo.r($1800.3) ; PDO inhibit time      ?
@print "TxPDO1CommPar.CMSpr= %03ld",sdo.r($1800.4) ; PDO CMS priority (no) ?
@print "TxPDO1CommPar.EvTim= %05ld",sdo.r($1800.5) ; PDO event timer [ms]  ?
@sdo.w ($1800.5, U16, 100) ; set TPDO1 event timer [ms] (-> TXcycle if TxType==255)
@sdo.w ($1800.5, U16, 0) ; 0 = PDO event timer off
@sdo.w ($1801.5, U16, 100) ; set TPDO2 event timer [ms] (-> TXcycle if TxType==255)


   ;
   ; 0x1A00 = 1st TPDO Mapping parameter
@print "TxPDO1Mapping.NrObj= %05ld",sdo.r($1A00.0) ; Number of mapped objs ?
@print "TxPDO1Mapping.Obj.1=$%08lX",sdo.r($1A00.1) ; First mapped object   ?
@print "TxPDO1Mapping.Obj.2=$%08lX",sdo.r($1A00.2) ; 2nd   mapped object   ?
@print "TxPDO1Mapping.Obj.3=$%08lX",sdo.r($1A00.3) ; 3rd   mapped object   ?
@print "TxPDO1Mapping.Obj.4=$%08lX",sdo.r($1A00.4) ; 4th   mapped object   ?
@stop  ; A "user-defined" PDO-Mapping for the 1st Transmit, for I/O-MODULE:
@sdo.w($1A00.0, U8,  0)  ; Begin to modify mapping table for TPDO1
@sdo.w($1A00.1, U32, 0x60000108) ; 1st mapped object: 8 digital inputs
@sdo.w($1A00.2, U32, 0x60000108) ; 2nd mapped object: the same once again !
@sdo.w($1A00.3, U32, 0x60000108) ; 3rd mapped object: the same once again !
@sdo.w($1A00.0, U8,  3)  ; Map X objects into TPDO1
@sdo.w($1010.1, U32, 0x65766173) ; SAVE ALL PARAMETERS (!)
@stop  ; A "user-defined" PDO-Mapping for the 1st Transmit, for UPT-167:
@sdo.w($1A00.0, U8,  0)  ; Begin to modify mapping table for TPDO1
@sdo.w($1A00.1, U32, 0x40010108) ; 1st mapped object: 8 digital inputs
@sdo.w($1A00.2, U32, 0x60000108) ; 2nd mapped object: the same once again !
@sdo.w($1A00.3, U32, 0x60000108) ; 3rd mapped object: the same once again !
@sdo.w($1A00.0, U8,  3)  ; Map X objects into TPDO1
@sdo.w($1010.1, U32, 0x65766173) ; SAVE ALL PARAMETERS (!)

   ;
   ; 0x1A01 = 2nd TPDO Mapping parameter
@print "TxPDO2Mapping.NrObj= %05ld",sdo.r($1A01.0) ; Number of mapped objs ?
@print "TxPDO2Mapping.Obj.1=$%08lX",sdo.r($1A01.1) ; First mapped object   ?
@print "TxPDO2Mapping.Obj.2=$%08lX",sdo.r($1A01.2) ; 2nd   mapped object   ?
@print "TxPDO2Mapping.Obj.3=$%08lX",sdo.r($1A01.3) ; 3rd   mapped object   ?
@print "TxPDO2Mapping.Obj.4=$%08lX",sdo.r($1A01.4) ; 4th   mapped object   ?

   ;
   ; 0x1A02 = 3rd TPDO Mapping parameter
@print "TxPDO3Mapping.NrObj= %05ld",sdo.r($1A02.0) ; Number of mapped objs ?
@print "TxPDO3Mapping.Obj.1=$%08lX",sdo.r($1A02.1) ; First mapped object   ?
@print "TxPDO3Mapping.Obj.2=$%08lX",sdo.r($1A02.2) ; 2nd   mapped object   ?
@print "TxPDO3Mapping.Obj.3=$%08lX",sdo.r($1A02.3) ; 3rd   mapped object   ?
@print "TxPDO3Mapping.Obj.4=$%08lX",sdo.r($1A02.4) ; 4th   mapped object   ?

@stop  ;  Modify TPDO #3 ...
@sdo.w($1802.1, U32, 0x00000381) ; Modify CAN-Identifier used by PDO
@sdo.w($1010.1, U32, 0x65766173) ; "save" ALL PARAMETERS (!)
000 81 00                        ; Node Reset
@print "TPDO3_CobID=$%08lX",sdo.r($1802.1) ; read to check storage



;-------------- "receive" - PDO (analoge+digitale Outputs) -----------------
   ;
   ; 0x1400 = 1st RPDO Communication parameter
@print "RxPDO1CommPar.Sub0=%ld",sdo.r($1400.0)
@print "RxPDO1CommPar.CobID=$%08lX",sdo.r($1400.1) ; PDO ID of 1st RPDO    ?
@print "RxPDO1CommPar.TrTyp= %03ld",sdo.r($1400.2) ; PDO transmission type ?
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
@print "RxPDO1CommPar.Inhib= %05ld",sdo.r($1400.3) ; PDO inhibit time      ?
@print "RxPDO1CommPar.CMSpr= %03ld",sdo.r($1400.4) ; PDO CMS priority (no) ?
@print "RxPDO1CommPar.EvTim= %05ld",sdo.r($1400.5) ; PDO event timer [ms]  ?
   ;
   ; 0x1401 = 2nd RPDO Communication parameter
@print "RxPDO2CommPar.Sub0=%ld",sdo.r($1401.0)
@print "RxPDO2CommPar.CobID=$%08lX",sdo.r($1401.1) ; PDO ID of 2nd RPDO    ?
@print "RxPDO2CommPar.TrTyp= %03ld",sdo.r($1401.2) ; PDO transmission type ?
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
@print "RxPDO2CommPar.Inhib= %05ld",sdo.r($1401.3) ; PDO inhibit time      ?
@print "RxPDO2CommPar.CMSpr= %03ld",sdo.r($1401.4) ; PDO CMS priority (no) ?
@print "RxPDO2CommPar.EvTim= %05ld",sdo.r($1401.5) ; PDO event timer [ms]  ?
   ;
   ; 0x1600 = 1st RPDO Mapping parameter
@print "RxPDO1Mapping.NrObj= %05ld",sdo.r($1600.0) ; Number of mapped objs ?
@print "RxPDO1Mapping.Obj.1=$%08lX",sdo.r($1600.1) ; First mapped object   ?
@print "RxPDO1Mapping.Obj.2=$%08lX",sdo.r($1600.2) ; 2nd   mapped object   ?
@print "RxPDO1Mapping.Obj.3=$%08lX",sdo.r($1600.3) ; 3rd   mapped object   ?
@print "RxPDO1Mapping.Obj.4=$%08lX",sdo.r($1600.4) ; 4th   mapped object   ?
   ;
   ; 0x1601 = 2nd RPDO Mapping parameter
@print "RxPDO2Mapping.NrObj= %05ld",sdo.r($1601.0) ; Number of mapped objs ?
@print "RxPDO2Mapping.Obj.1=$%08lX",sdo.r($1601.1) ; First mapped object   ?
@print "RxPDO2Mapping.Obj.2=$%08lX",sdo.r($1601.2) ; 2nd   mapped object   ?
@print "RxPDO2Mapping.Obj.3=$%08lX",sdo.r($1601.3) ; 3rd   mapped object   ?
@print "RxPDO2Mapping.Obj.4=$%08lX",sdo.r($1601.4) ; 4th   mapped object   ?
@goto PdoTest  ; switch to "operational" and send a few PDO's ...


;----------- Objekte aus device profile (gibt's beim Terminal nicht!) ------
@print sdo.r($6000.254) ; what's the NAME of this object ?
@print "NR_DIGIN= %ld * 8bit",sdo.r($6000.0)   ; number of digital inputs
@print "ST_DIGIN= $%02lX",sdo.r($6000.1)       ; state of first 8 digital inputs
@print sdo.r($6200.254) ; what's the NAME of this object ?
@print "NR_DIGOUT=%ld * 8bit",sdo.r($6200.0)   ; number of digital outputs
@print "ST_DIGOUT=$%02lX",sdo.r($6200.1)       ; state of first 8 digital outputs
@sdo.write( $6200.1, U8, 255 )                 ;  set state of first 8 digital outputs
@sdo.write( $6200.1, U8, 0   )                 ;  set state of first 8 digital outputs
@print "FAULT_MOD=%ld",sdo.r($6206.1) ; read fault mode for 8 outputs
@sdo.write( $6206.1, U8, 255 ) ;  all outputs revert to a predefined state
@sdo.write( $6206.1, U8, 0   ) ;  all outputs keep their current states
@print sdo.r($6401.254) ; what's the NAME of this object ?
@print "NR_AN_IN =%ld",sdo.r($6401.0) ; read number of analog Inputs
@print "AIN0     =%ld",sdo.r($6401.1) ; read 1st 16-bit-analog Input
@print "AIN1     =%ld",sdo.r($6401.2) ; read 2nd 16-bit-analog Input
@sdo.w($6401.1,I16,1234)       ; WRITE access to analog input should fail
@print "NR_AN_OUT=%ld",sdo.r($6411.0) ; read number of analog Outputs
@sdo.w($6411.1,I16,0)      ; set 1st analog output to ZERO
@sdo.w($6411.1,I16,16383)  ; set 1st analog output to MID-RANGE
@sdo.w($6411.1,I16,32767)  ; set 1st analog output to MAXIMUM
@sdo.w($6411.2,I16,0)      ; set 2nd analog output to ZERO
@sdo.w($6411.2,I16,16383)  ; set 2nd analog output to MID-RANGE
@sdo.w($6411.2,I16,32767)  ; set 2nd analog output to MAXIMUM



@stop
(S) 22 $1010.w 1 "save"   ; "save" Parameters ($1010.1) in EEPROM

;----------- "manufacturer specific", Codenummern aus "TERMINAL-Handbuch" --------------
@print "CurrPage=%ld",sdo.r($5105.1)     ; Nummer der aktuellen Anzeigeseite
@sdo.w($5105.1,U8, 0 )    ; switch to page nr 0
@sdo.w($5105.1,U8, 1 )    ; switch to page nr 1
@sdo.w($5105.1,U8, 2 )    ; switch to page nr 2
@sdo.w($5105.1,U8, 1000 ) ; switch to page nr 1000 (must be rejected w. ERROR CODE)
@print "NrInt16Vars=%ld",sdo.r($4003.0)   ; Anzahl der 16-Bit-INTEGER-Variablen
@print "NrInt32Vars=%ld",sdo.r($4004.0)   ; Anzahl der 32-Bit-INTEGER-Variablen
@print "NrUns8Vars=%ld", sdo.r($4005.0)   ; Anzahl der  8-Bit-UNSIGNED-Variablen
@print "NrUns16Vars=%ld",sdo.r($4006.0)   ; Anzahl der 16-Bit-UNSIGNED-Variablen
@print "NrUns32Vars=%ld",sdo.r($4007.0)   ; Anzahl der 32-Bit-UNSIGNED-Variablen
@print "NrStringVars=%ld",sdo.r($4009.0)  ; Anzahl der STRING-Variablen
@print "CurrPage=%ld",sdo.r($5105.1)      ; Nummer der aktuellen Anzeigeseite
@print "Int16Var[1]=%ld",sdo.r($4003.1,I16)  ; erste 16-Bit-INTEGER-Variable lesen
@sdo.w($4003.1,I16, 12345)                ; erste 16-Bit-INTEGER-Variable setzen
@print "Int32Var[10]=%ld",sdo.r($4004.10) ; zehnte 32-Bit-INTEGER-Variable lesen
@sdo.w($4004.10,I32, -1234567890)         ; zehnte 32-Bit-INTEGER-Variable setzen
@print sdo.r($4009.5,STR)                 ; fuenfte STRING-Variable lesen
@print sdo.r($4009.6,STR)                 ; sechste STRING-Variable lesen
@sdo.w($4009.5,STR, "Dies ist ein Test")  ; fuenfte STRING-Variable setzen
@sdo.w($4009.6,STR, "String Number Six")  ; sechste STRING-Variable setzen

; Objekt 0x5111 dient bei "programmierbaren Terminals mit SYS TEC's CANopen"
;   zur zeilenweisen Uebertragung des "ANZEIGEPROGRAMMS" als String :
ReadTerminalProg:
@sdo.w($5111,STR,"!send_program!")  ; Terminal soll sein Programm SENDEN ("auslesen")
ProgReadLoop:
  @print sdo.r($5111,STR)           ; naechste Textzeile lesen
@goto ProgReadLoop
@sdo.w($5111,STR,"!run!")           ; Terminal-Applikation starten
@sdo.w($5111,STR,"!receive_program!")  ; Terminal soll sein Programm EMPFANGEN
@sdo.w($5111,STR,"!finish_transfer!")  ; Transfer beenden




;--------- "manufacturer specific", einige Objekte aus EA-Modul "SAHM" / "IP65" : ------
@print "FreqInputsSupported=%lX",sdo.r($5C00.0))  ; -> 1=Frequenz-Input #1 vorhanden
@print "FreqInp1NrOfSubs=%lX",  sdo.r($5C01.0))   ; Hoechster Subindex dieses Objekts
@print "FreqInp1GateTimeMs=%ld",sdo.r($5C01.1))   ; Torzeit in Millisekunden (Default: 10ms)
@print "FreqInp1PulseCount=%ld",sdo.r($5C01.2))   ; Anzahl Pulse innerhalb der Torzeit
@print "FreqInp1PulseTDiff=%ld",sdo.r($5C01.3))   ; Differenz erster bis letzter Puls (10us)
@print "FreqInp1Freqcy_Hz=%ld",sdo.r($5C01.4))   ; daraus berechnete Frequenz (16bit, Hz)
FL:
 @print "FreqInput32_01Hz=%ld",sdo.r($5C01.5))   ; dito, mit 32 bit, Einheit= 0.1-Hz
@goto FL
@stop
@sdo.w($5C01.1,U16, 100)   ; Torzeit fuer Frequenzzaehler setzen
@sdo.w($5C01.1,U16, 10)    ; Torzeit fuer Frequenzzaehler setzen






@stop ; end diagnostic READ section

(S) 22 $1010.w 1 "save"           ; "save" Parameters ($1010.1) in EEPROM

;--- Aufruf spezieller Test-und Einstellprozeduren (Codenummern 2048...) -----

;====== Zustandsuebergaenge des CANopen-Knotens (Test) =======================
($700+N)rXX ; Anforderung Node-Guard-Status mit RTR (nur mit NEUEM PCAN-USB!)
000 01 00   ; "Start Remode Node" ("Node Start Protocol" in DS203-2 p.7)
000 02 00   ; "Stop Remote Node"
000 03 00   ; "Disconnect Remote Node"       (DS203-2 p.8,  kennt SYS TEC wohl nicht)
000 80 00   ; "Enter Preoperational State"
000 81 00   ; Operational -> Initialisation (d.h. Reset)
#128 0      ; Sync-Telegramm
@stop
@reset  ; reset time, counters and warn-flags of the DOS-CAN-Tester

LaufLicht:  ;====== Ansteuern der 8 digitalen I/Os per PDO =======
 @gosub ExtBoot ; "Extended Bootup" wichtig fuer Node-Guarding.
 000 01 00  ; Modul von Pre-Operational -> Operational schalten, PDOs aktiv.
Lauf1:      ; Auch fuer LENZE mit Master/Slave - Kaskadierung (oh Graus...)
 (P) 01 C0 07 F0
 (P) 02 60 0E 78
 (P) 04 30 1C 3C
 (P) 08 18 38 1E
 (P) 10 0C 70 0F
 (P) 20 06 E0 87
 (P) 40 03 C1 C3
 (P) 80 01 83 E1
 ($700+N)rXX ; Anforderung Node-Guard-Status via RTR
@goto Lauf1

ExtBoot:     ; Unterprogramm "Bootup MIT Nodeguarding und SYNC"
000 80 00    ; Enter Pre-Operational State
000 03 00    ; Disconnect -> Antwort "#2022"=identify node
($700+N)rXX  ; Anforderung Node-Guard-Status
(#2026) 04 (N) 00 00 00 00 00 00  ; Connect Remote Node ("Teil 1")
(#2026) 06 00  FF 00 00 00 00 00  ; "Identify Remote Nodes" (!!??!!)
(#2026) 02 (N) (N) 07 00 10 02 02 ; Node Guarding Vorbereitung [203-2p4],"T.2"
(#2026) 03 (N) 01 00 00 00 00 00  ; Prepare Remote Node
@return  ; Ende "ExtBoot"


PdoTest:  ; Test : Switch to "operational" and send something to the RPDO's :
@A=0        ;
000 01 00   ; "Start Remode Node" ("Node Start Protocol" in DS203-2 p.7)
            ; Note: The SYS TEC stack reacts with an EMERGENCY TELEGRAM
            ;       if the count of bytes in an RPDO is not correct ! ! ! 
PdoTestL:
 $201 FF FF ; -> RPDO1 vom E/A-Modul (digitale Outputs)
 $201 00 00
 $201 11 11
 $201 22 22
 $201 44 44
 $201 88 88
 $301 (A).w (A+0x3FFF).w  ; -> RPDO2 vom E/A-Modul (analoge Outputs)
 @A=(A+1024)&0x7FFF
@goto PdoTestL


; <EOF>
