;-- EA515_8IO_DS401  (Digital-Tests fuer MKTs EA515-Modul 8 I/O im "DS401-Modus") 
;   Autor:  Wolfgang Buescher      Stand: 2008-03-13
;   Originaldatei: //WoBu5/c/CBproj/CanTest/Programs/EA515_8IO_DS401.cts .
;   Testdatei fuer EA515 im DS401-Modus: EA515_8IO_DS401.cts
;   Testdatei fuer EA515 im LENZE-Modus: EA515_8IO_LENZE.cts
; Wegen diverser Sonderfunktionen NUR MIT CAN-TESTER FUR WINDOWS lauffhig !
; Falls sich das Programm merkwrdig benimmt, bitte den CAN-Tester updaten .

Neustart:
can.reset        // CAN-Controller ruecksetzen (hilft gegen BUS-OFF und Bug im Peak-Treiber)
@NumErrors := 0  // clear error counter
@tx_interval=0.01  // set TX interval, also limits execution speed: SECONDS per line
OnError goto Verflixt // define error handler (jump if "something" goes wrong)


;-- Einstellung Variablen ---------------------------------------------------
OpenWindow( "E/A515-8IO-DS401 Test Vorbereitung",w=600, h=500)
 SetFont("Arial",8,1)
 @N=1  ; Node-ID (==DIP-Schalter-Adresse)
 @J=384+N   ; Identifier f. PDO EA->Master (Inputs,Lenze: 767+N, DS401:384+N)
 @P=512+N   ; Identifier f. PDO Master->EA (Outputs,Lenze: 768+N, DS401:512+N)
 @S=1536+N  ; SDO(rx) des E/A-Master-Moduls
 @T=1408+N  ; SDO(tx) des E/A-Master-Moduls (!)
 @Y= 1      ; Option: 0=ohne SYNC  1=mit SYNC
 @L= 1      ; Option: 0=Laufl.aus  1=Laufl.an
 @sdo.node(N)    ; Node-ID fuer SDO-Zugriffe mit sdo.read() und sdo.write()
 @print "NODE-ID fuer SDO-Zugriffe = %ld", sdo.node
 print N,J,P,S,T,Y,L  ; Test: press F2 with cursor in this line to check settings !
 print "CAN: %ld kBit/sec",can.baudrate
 @tx_interval=0.1  // set TX interval, also limits execution speed: SECONDS per line


Identifikation:
OpenWindow( "E/A515-8IO-DS401 Test Schritt 1 : Identifikation", w=600, h=500 )
 ClearScreen() : SetFont("Arial",20,1) : print("CANopen-Objekte zur Modul-Identifikation"
 SetFont("Arial",8,1) : MoveTo(20,40)
 print "Modul-Identifikation" : SetFont("Arial",8,0)
 ;----- Communication Profile (DS301 V4) -------------------
 @print "DevType=$%08lX",sdo.r($1000.0)
 @print "ErrorReg=$%08lX",sdo.r($1001.0)
 @print "ManufStatusReg=$%08lX",sdo.r($1002.0)
 @print "PreDefErrorFld=$%08lX",sdo.r($1003.0) 
 @print "NumberOftotalPDOs=$%08lX",sdo.r($1004.0)
 @print "NumberOfsynchPDOs=$%08lX",sdo.r($1004.1)
 @print "NumberOfasyncPDOs=$%08lX",sdo.r($1004.2)
 @print "DeviceName=$%08lX",sdo.r($1008.0)
 @print "HardwareVs=$%08lX",sdo.r($1009.0)
 @print "SoftwareVs=$%08lX",sdo.r($100A.0)
 @print "Comp-date: %c%c%c%c%c%c%c%c",sdo.r($5F9D.1),sdo.r($5F9D.2),sdo.r($5F9D.3),sdo.r($5F9D.4),sdo.r($5F9D.5),sdo.r($5F9D.6),sdo.r($5F9D.7),sdo.r($5F9D.8))

 // Ab hier darf der Bediener "abkrzen" (wenn er will), 
 // darum werden JETZT die Buttons eingeblendet :
 SetButton( 2, "&Beenden",   goto Beenden    )
 SetButton( 3, "&Ausgangs-Test >>", goto OutputTest )

 SetFont("Arial",8,1) : MoveTo(210,40)
 print "Objekte nach DS301 + DS401" : SetFont("Arial",8,0)
 @print "GuardTime=$%08lX",sdo.r($100C.0)
 @print "LifeTimeFactor=$%08lX",sdo.r($100D.0)
 // Alle auskommentierten Objekte funktionieren nicht bzw existieren hier nicht !
 ;@print "CobIdTimestamp=$%08lX",sdo.r($1012.0)
 ;@print "CobIdEmergency=$%08lX",sdo.r($1014.0)
 ;@print "EmgcyInhibitTi=$%08lX",sdo.r($1015.0)
 ;@print "ProducerHeartb=$%08lX",sdo.r($1017.0)
 ;@print "IdentityObjectSubis=%08lX",sdo.r($1018.0)
 @print "NR digital Inputs= %ld * 8bit",sdo.r($6000.0)   ; number of digital inputs
 @print "STATUS dig.Inputs= $%02lX",sdo.r($6000.1)   ; state of first 8 digital inputs
 @print "NR digital Outputs=%ld * 8bit",sdo.r($6200.0)   ; number of digital outputs
 @print "Status dig.Outputs=$%02lX",sdo.r($6200.1)   ; state of first 8 digital outputs
 @print "Fault mode =%ld",sdo.r($6206.1) ; read fault mode for 8 outputs
 ;@print "NR_AN_IN =%ld",sdo.r($6401.0) ; read number of analog Inputs
 ;@print "AIN0     =%ld",sdo.r($6401.1) ; read 1st 16-bit-analog Input
 ;@print "NR_AN_OUT=%ld",sdo.r($6411.0) ; read number of analog Outputs
 @print "Bootup-Delay= %ld ms", sdo.r( ($5FFF-#05).0 )  ; Read  BOOTUP DELAY TIME (milliseconds)
 @print "DRIVE Ident = %ld (fr Lenze)",sdo.r(($5FFF-#93).0 ) ; READ Drive Ident (-> 5150 )
 @print "Spec.options= $%lX",sdo.r( ($5FFF-#19).0 ) ; Read CFG_data.option_flags:
  ; b0=DS401 b1=COUNTER b2=?? b3=?? b4=SLAVE_ENABLE b5=AUTO_SAVE  b6=NO_NMT
 @print "HardwareMod.=$%02lX",sdo.r(($5FFF-#18).0 ) ; READ  Hardware Model
  ; ($00=8IO, $40=DA4)



 SetFont("Arial",8,1) : MoveTo(20,240)
 print "Transmit-PDO-Konfiguration" : SetFont("Arial",8,0)
 @print "TxPDO1CommPar.Sub0=%ld",sdo.r($1800.0)
 @print "TxPDO1CommPar.CobID=$%08lX",sdo.r($1800.1) ; PDO ID of 1st TPDO    ?
 @print "TxPDO1CommPar.TrTyp= %03ld",sdo.r($1800.2) ; PDO transmission type ?
  ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
 ;@print "TxPDO1CommPar.Inhib= %05ld",sdo.r($1800.3) ; PDO inhibit time      ?
 ;@print "TxPDO1CommPar.CMSpr= %03ld",sdo.r($1800.4) ; PDO CMS priority (no) ?
 ;@print "TxPDO1CommPar.EvTim= %05ld",sdo.r($1800.5) ; PDO event timer [ms]  ?
 @print "TxPDO1Mapping.NrObj= %05ld",sdo.r($1A00.0) ; Number of mapped objs ?
 @print "TxPDO1Mapping.Obj.1=$%08lX",sdo.r($1A00.1) ; First mapped object   ?
 ;@print "TxPDO1Mapping.Obj.2=$%08lX",sdo.r($1A00.2) ; 2nd   mapped object   ?
 ;@print "TxPDO1Mapping.Obj.3=$%08lX",sdo.r($1A00.3) ; 3rd   mapped object   ?
 ;@print "TxPDO1Mapping.Obj.4=$%08lX",sdo.r($1A00.4) ; 4th   mapped object   ?

 SetFont("Arial",8,1) : MoveTo(210,240)
 print "Receive-PDO-Konfiguration" : SetFont("Arial",8,0)
 @print "RxPDO1CommPar.Sub0=%ld",sdo.r($1400.0)
 @print "RxPDO1CommPar.CobID=$%08lX",sdo.r($1400.1) ; PDO ID of 1st RPDO    ?
 @print "RxPDO1CommPar.TrTyp= %03ld",sdo.r($1400.2) ; PDO transmission type ?
  ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
 ;@print "RxPDO1CommPar.Inhib= %05ld",sdo.r($1400.3) ; PDO inhibit time      ?
 ;@print "RxPDO1CommPar.CMSpr= %03ld",sdo.r($1400.4) ; PDO CMS priority (no) ?
 ;@print "RxPDO1CommPar.EvTim= %05ld",sdo.r($1400.5) ; PDO event timer [ms]  ?
 @print "RxPDO1Mapping.NrObj= %05ld",sdo.r($1600.0) ; Number of mapped objs ?
 @print "RxPDO1Mapping.Obj.1=$%08lX",sdo.r($1600.1) ; First mapped object   ?
 ;@print "RxPDO1Mapping.Obj.2=$%08lX",sdo.r($1600.2) ; 2nd   mapped object   ?
 ;@print "RxPDO1Mapping.Obj.3=$%08lX",sdo.r($1600.3) ; 3rd   mapped object   ?
 ;@print "RxPDO1Mapping.Obj.4=$%08lX",sdo.r($1600.4) ; 4th   mapped object   ?


Warten: 
  goto Warten  // Diese nette Endlosschleife wird per Button-Event verlassen !
CloseWindow()


;----------------------------------------------------------------------
; Test der digitalen Ausgnge, nur fuer altes E/A515-8I/O !!
;----------------------------------------------------------------------
OutputTest:
 // In diesem Schritt aktivieren wir die digitalen Ausgaenge .
 // ACHTUNG: DIESER SCHRITT DARF NICHT "EINFACH SO" VERLASSEN WERDEN !
 // DAS GERAET DARF NICHT MIT ALS OUTPUT KONFIGURIERTER KLEMME
 // ZUM KUNDEN GELANGEN !
 OpenWindow( "E/A515-8IO-DS401 Test Schritt 1 : Digitale AUSGNGE", w=600, h=500 )
 ClearScreen() : SetFont("Arial",12,0) : MoveTo(20,40) 
 print("Fr den nchsten Test werden aus den digitalen EINGNGEN")
 print("nun digitale AUSGNGE gemacht   !")
 @delay(0.5)
 MoveTo(60,140) 
 print("Der folgende Test darf AUF KEINEN FALL abgebrochen werden,")
 print("weil sonst die Gefahr besteht dass ein versehentlich als")
 print("Modul mit DIGITALEN AUSGNGEN zum Kunden gelangt.")
 @delay(0.5)
 MoveTo(80,240) 
 print("Im Auslieferungszustand drfen die E/A-Module aber nur")
 print("digitale EINGNGE haben   -    keine Ausgnge !")
 MoveTo(40,300) 
 print("Bitte warten..")
 @delay(1.0) // warten, falls nun eine Panikattacke einsetzt ;-)

 ;----- Einstellung Port-Richtungen beim ALTEN EA-515 8I/O: ------
 ; Um aus den Eingaengen digitale Ausgaenge zu machen,
 ;  die folgenden DREI Zeilen LANGSAM NACHEINANDER ausfuehren (mit F2).
 @sdo.w(($5FFF-#10).0, U32, $FFFFFFFF) ; WRITE: port directions (save+reset!!)
 @sdo.w($1010.1, U32, $65766173) ; Save Parameters ($1010.1) "save"=73 61 76 65h
 000 81 00               ; Reset Module (aehnlich wie Kaltstart)
 @delay(2)
 SetButton( 1, "&Weiter >>",   goto StopOutputTest)
 ClearScreen() : SetFont("Arial",20,1) : print("Digitale Ein/Ausgnge EA-xxx")
 SetFont("Arial",8,1) : MoveTo(20,40) 
 print("Digitale Ausgnge beobachten (Lauflicht-Test) ...")
LaufLicht:  ;====== Ansteuern der 8 digitalen I/Os per PDO =======
 @gosub ExtBoot ; "Extended Bootup" wichtig fuer Node-Guarding.
 000 01 00  ; Modul von Pre-Operational -> Operational schalten, PDOs aktiv.
 @tx_interval=0.05  // set TX interval, also limits execution speed: SECONDS per line
Lauf1:      ; Auch fuer LENZE mit Master/Slave - Kaskadierung (oh Graus...)
 (P) 01 C0 07 F0
 gosub ShowDigIn
 (P) 02 60 0E 78
 gosub ShowDigIn
 (P) 04 30 1C 3C
 gosub ShowDigIn
 (P) 08 18 38 1E
 gosub ShowDigIn
 (P) 10 0C 70 0F
 gosub ShowDigIn
 (P) 20 06 E0 87
 gosub ShowDigIn
 (P) 40 03 C1 C3
 gosub ShowDigIn
 (P) 80 01 83 E1
 gosub ShowDigIn
 ($700+N)rXX ; Anforderung Node-Guard-Status via RTR
@goto Lauf1

ShowDigIn:
  MoveTo(0,150) : SetFont("Courier New",20)
  print "Digitale Inputs = %08bbin ",sdo.r($6000.1)
  return
// end ShowDigIn

StopOutputTest:
 ; Um aus den Ausgaengen wieder digitale Eingaenge zu machen,
 ;  die folgenden DREI Zeilen LANGSAM NACHEINANDER ausfuehren (mit F2).
 OpenWindow( "E/A515-8IO-DS401 Test Nachbereitung",w=600, h=500)
 ClearScreen() : SetFont("Arial",12,1) : MoveTo(20,40) 
 print("Bitte warten, aus den digitalen AUSGNGEN")
 print("werden wieder digitale EINGNGE gemacht !")
 print
 @sdo.w(($5FFF-#10).0, U32, $00000000) ; WRITE: port directions (save+reset!!)
 @delay(1)
 @sdo.w($1010.1, U32, $65766173) ; Save Parameters ($1010.1) "save"=73 61 76 65h
 @delay(1)
 000 81 00               ; Reset Module (aehnlich wie Kaltstart)
 @delay(1)
 MoveTo(60,140) : SetFont("Arial",12,0)
 print("Uff, geschafft.. die Anschlussklemmen sind jetzt wieder")
 print("als digitale EINGNGE konfiguriert, die im nchsten Schritt")
 print("getest werden .")
 SetButton( 1, " &Beenden",   goto Beenden  )
 SetButton( 2, "&Weiter >>",  goto InputTest)
Warten2:
 goto Warten2


;----------------------------------------------------------------------
; Test der digitalen Eingnge, nur fuer altes E/A515-8I/O !!
;----------------------------------------------------------------------
InputTest:
 OpenWindow( "E/A-Modul-Test : Digitale Eingnge" )
 SetButton( 1, "<< &Neustart", goto Neustart  )
 SetButton( 2, "&Weiter",      goto Fertig    )
 ClearScreen() : SetFont("Arial",20,1) : print("Digitale Ein/Ausgnge EA-515")
DigInfo:
 SetFont("Courier New",8) : MoveTo(10,40)
 print "Anzahl digitaler Eingnge      = %ld * 8bit",sdo.r($6000.0)
 print "Ursprnglicher Zustand d.d.E.  = $%02lX",sdo.r($6000.1)
 print
 SetFont("Courier New",10)
 print("Der Reihe nach H-Pegel an alle digitalen Eingnge anlegen,")
 print("und die Anzeige der digitalen Eingnge beobachten (unten).")
 @gosub ExtBoot ; "Extended Bootup" wichtig fuer Node-Guarding.
 000 01 00  ; Modul von Pre-Operational -> Operational schalten, PDOs aktiv.
DigInLoop:  ; digitale Eingnge per SDO lesen und BINR anzeigen :
  MoveTo(0,150) : SetFont("Courier New",25)
  print "Digitale Inputs = %08bbin ",sdo.r($6000.1)
  delay(0.1)
@goto DigInLoop



;====== Zustandsuebergaenge des EA-Moduls (Test) ============================
($700+N)rXX  ; Anforderung Node-Guard-Status mit RTR
000 01 00    ; "Start Remode Node" ("Node Start Protocol" in DS203-2 p.7)
000 02 00    ; "Stop Remote Node"
000 03 00    ; "Disconnect Remote Node"       (DS203-2 p.8)
000 80 00    ; "Enter Preoperational State"
000 81 00    ; Operational -> Initialisation (d.h. Reset)
#128 0       ; Sync-Telegramm
@stop
@reset  ; reset time, counters and warn-flags of the DOS-CAN-Tester

ExtBoot:     ; Unterprogramm "Bootup MIT Nodeguarding und SYNC"
000 80 00    ; Enter Pre-Operational State
000 03 00    ; Disconnect -> Antwort "#2022"=identify node
($700+N)rXX  ; Anforderung Node-Guard-Status
(#2026) 04 (N) 00 00 00 00 00 00  ; Connect Remote Node ("Teil 1")
(#2026) 06 00  FF 00 00 00 00 00  ; "Identify Remote Nodes" (!!??!!)
(#2026) 02 (N) (N) 07 00 10 02 02 ; Node Guarding Vorbereitung [203-2p4],"T.2"
(#2026) 03 (N) 01 00 00 00 00 00  ; Prepare Remote Node
@return  ; Ende "ExtBoot"


;--------- Alle Tests durch... -----------------------------------------------------
Fertig:
 000 81 00      ; NMT-Telegramm: Operational -> Initialisation (d.h. Reset)
 OpenWindow( "CAN-Test : FERTIG ! ",w=320,h=200,bc=(NumErrors==0)?green:yellow)
 SetFont("Arial",18,2) : MoveTo(0,40) 
 if(NumErrors==0)
    @sound( 10, 600, 100 )
    print " Glckwunsch, das war's !"
 else
    @sound( 1200, 600, -100 )
    print " Naja, %ld Fehler..",NumErrors
 endif
 print "   .. und was nun ?"
 SetButton( 1,"&Neustart", goto Neustart )
 SetButton( 2,"&Beenden",  goto Beenden )
FertigW:
goto FertigW



;--------- Bei Fehlern... ----------------------------------------------------------
Verflixt:
 if(ErrorClass==ErrorClass.sdo)  ; // most likely a non-existing object, or SDO timeout ?
   @NumErrors:=NumErrors+1 : delay(0.5) : ResumeError // Weitermachen !
 endif
 OpenWindow( "CAN-Test : FEHLER ! ",w=400,h=200,bc=red)
 SetFont("Arial",8) : MoveTo(8,4) 
 print( "Fehlercode %ld (Klasse %d) in Programmzeile %ld", ErrorInfo.code, ErrorClass, ErrorInfo.line )
 print( ErrorInfo.text )
 SetFont("Arial",11,2) : MoveTo(8,40) 
 print "- CAN-Baudrate berprfen (momentan %ld kBit/sec)",can.baudrate
 print "- Knotennummer berprfen (momentan #%ld )",sdo.node
 print "- die verdammten Kabel berprfen"
 print "- die DIP-Schalter richtig einstellen"
 SetButton( 1,"&Nochmal versuchen",  goto Neustart )
 SetButton( 2,"&Abbrechen",  goto Abbruch )
 ClearError()   ; OnError-Handler wieder "scharf" machen
Fehlerschleife:
goto Fehlerschleife
Abbruch:  ; ABBRUCH im Fehlerfall, ohne nochmaligen CAN-Sendeversuch !
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmabbruch - Neustart mit F9 !"
@stop



;--------- Test Ende ---------------------------------------------------------------
Beenden:  ; Planmaessiges TEST-ENDE, mit Abschalten der PDOs
 000 81 00      ; NMT-Telegramm: Operational -> Initialisation (d.h. Reset)
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmende - Neustart mit F9 !"
@stop           ; stop command program. Press F9 to restart .



; <EOF>
