;---- KWP / TP - Simulator (Anweisungsdatei fr CAN-Tester) : SERVER ------
;   (Ersatz fr ein paar ECUs, basiert auf "20060327_Beispiel_KWP.asc")
;
; Programm starten mit F9 bzw. "Run"..."Start"  !
;
; Autor: Wolfgang Buescher     Stand: 2006-04-04
;   Ablage des Originals: //WoBu3/c/CBproj/CanTest/Programs/KWP_TP_Sim_Srv.TXT .
;
; Wegen diverser Sonderfunktionen NUR MIT CAN-TESTER FUR WINDOWS lauffhig !
; Zum Testen erst auf einem PC den "Server" starten, danach auf dem anderen PC
; den "Client".
; Infomationen zum 'wcan'-Befehl in der Online-Hilfe !
;  (Cursor auf den Befehl setzen, dann CTRL-F1 drcken)
;
@tx_interval = 0.005  ; CAN-Sende-/ und Zeilen-Abarbeitungs-Intervall
ClearScreen(1)        ;  CAN-RX-Fenster lschen


Server:  ; Der SERVER beginnt mit "Warten auf Empfang"

; TP-Leseanforderungen beginnen (meistens) wie folgt:
wcan xxx X xx xx xx XX XX XX XX XX ; Warte auf erste Anfrage (meistens mit ZWEI Bytes KWP-Nutzdate)
@if(wcan.len<4) goto Server        ; mindestens 4 (?) Datenbytes in Single Frame
; Welcher "Parameter" (KWP-Kommando?) wurde angefordert ?
@Cmd = wcan.dat(0,M32) ; Datenbits 0..32 aus SF als "Motorola-32bit-Wert" merken (!)
@print("Received cmd 0x%08lX from ID 0x%04lX",Cmd,wcan.id)
; Basierend auf dem RX-Telegramm zur passenden "ECU-Simulation" umschalten
@if(wcan.id==0x04E0) goto "Srv4E0"
@if(wcan.id==0x07E0) goto "Srv7E0"
@if(wcan.id==0x07E1) goto "Srv7E1"
@if(wcan.id==0x0784) goto "Srv784"
@if(wcan.id==0x0788) goto "Srv788"
@if(wcan.id==0x0792) goto "Srv792"

; Hier angekommen ? War wohl nix !
@print "ERROR: CAN-ID 0x%lX not recognized !",wcan.id
;@stop        ; Simulation anhalten (irgendwas ist hier faul)
@goto Server  ; ..oder doch weitermachen ?

; Simulation der ANTWORTEN der einzelnen ECUs :

Srv4E0:  ; Simulation der ECU mit RX-ID 0x4E0 ============================
; Hier sind verschiedene Parameter in beliebiger Reihenfolge
; abfragbar. Dazu dient der folgende "Kommandoverteiler" :
@if((Cmd&0xFFFFFF00)==0x02210500) goto Srv4E0_2105 
@if((Cmd&0xFFFFFF00)==0x021A8700) goto Srv4E0_1A87
@if((Cmd&0xFFFFFFFF)==0x041802FF) goto Srv4E0_1802
@if((Cmd&0xFFFFFF00)==0x02217000) goto Srv4E0_2170
@goto Server  ; nicht verstanden; auf nchstes Kommando warten
Srv4E0_2105:  ; Erster Parameter dieser ECU : ----------
5FF        10 13 61 05 57 44 42 39 ; Antwort mit First Frame (FF)
wcan 4E0 8 30 08 28 xx xx xx xx xx ; Flow-Control abwarten (FC)
5FF        21 30 36 36 33 31 31 53 ; Consecutive Frame senden (CF)
5FF        22 31 30 30 33 35 38 4E ; Consecutive Frame senden (CF)
@goto Server  ; fertig mit diesem Parameter
Srv4E0_1A87:  ; Zweiter Parameter dieser ECU : ---------
; hier nach Empfang von 02 1A 87 00 00 00 00 00
5FF        10 16 5A 87 01 43 03 00
wcan 4E0 8 30 08 28 xx xx xx xx xx
5FF        21 00 04 45 05 32 00 39
5FF        22 30 36 35 34 35 30 31
5FF        23 30 38 00 00 05 8F 00
@goto Server  ; fertig mit diesem Parameter
Srv4E0_1802: ; Dritter Parameter dieser ECU: ----------
; hier nach Empfang von 04 18 02 FF 00 00 00 00
5FF        02 58 00 00 00 05 8F 00
@goto Server  ; fertig mit diesem Parameter
Srv4E0_2170: ; Vierter Parameter dieser ECU: ----------
; hier nach Empfang von 02 21 70 00 00 00 00 00
5FF        10 27 61 70 09 00 E0 5C
wcan 4E0 8 30 08 28 xx xx xx xx xx
5FF        21 28 73 14 4B 10 3C 98 ; "Folgemessages" ?!
5FF        22 01 27 11 88 00 2F 4E
5FF        23 4E 00 00 00 05 8F 00
5FF        24 00 00 00 00 12 51 01
5FF        25 A4 00 00 00 00 00 00 ; danach kommt nix mehr (!)
@goto Server  ; fertig mit ECU-ID 0x4E0 !


Srv7E0:  ; Simulation der ECU mit RX-ID 0x7E0 ============================
; Auch hier sind verschiedene Parameter in beliebiger Reihenfolge
; abfragbar. Dazu dient der folgende "Kommandoverteiler" :
@if(Cmd==0x021A8700) goto Srv7E0_1A87
@if(Cmd==0x041802FF) goto Srv7E0_1802
@goto Server  ; nicht verstanden; auf nchstes Kommando warten
Srv7E0_1A87:  ; Hier nach Empfang von 02 1A 87 00 00 00 00 00 :
7E8        10 16 5A 87 01 03 CA 51  ; erste Antwort (SW-Stand)
wcan 7E0 8 30 08 28 xx xx xx xx xx  ; erwarte Flow-Control
7E8        21 FF FF FF 06 11 00 30
7E8        22 30 32 34 34 36 36 36
7E8        23 34 30 00 00 00 00 00
@goto Server  ; fertig mit diesem Parameter
Srv7E0_1802:  ; Hier nach Empfang von 04 18 02 FF 00 00 00 00 :
7E8        02 58 00 00 00 00 00 00
@goto Server  ; fertig mit ECU-ID 0x7E0 !


Srv7E1:  ; Simulation der ECU mit RX-ID 0x7E1 ============================
; Auch hier sind verschiedene Parameter in beliebiger Reihenfolge
; abfragbar. Dazu dient der folgende "Kommandoverteiler" :
@if(Cmd==0x021A8700) goto Srv7E1_1A87
@if(Cmd==0x041802FF) goto Srv7E1_1802
@goto Server  ; nicht verstanden; auf nchstes Kommando warten
Srv7E1_1A87:  ; Hier nach Empfang von 02 1A 87 00 00 00 00 00 :
7E9        10 16 5A 87 03 08 03 52  ; erste Antwort (SW-Stand)
wcan 7E1 8 30 08 28 xx xx xx xx xx  ; erwarte Flow-Control
7E9        21 FF 05 24 05 30 00 30
7E9        22 30 32 34 34 36 39 38
7E9        23 31 30 FF FF FF FF FF
@goto Server  ; fertig mit diesem Parameter
Srv7E1_1802:  ; Hier nach Empfang von 04 18 02 FF 00 00 00 00 :
7E9        02 58 00 FF FF FF FF FF  ; Antwort nur 2 Byte
@goto Server  ; fertig mit ECU-ID 0x7E1 !


Srv784:  ; Simulation der ECU mit RX-ID 0x784 ============================
; Auch hier sind verschiedene Parameter in beliebiger Reihenfolge
; abfragbar. DIESE ECU laesst sich in einem Kommando "zweimal bitten" !
@if(Cmd==0x021A8700) goto Srv784_1A87
@if(Cmd==0x041802FF) goto Srv784_1802
@goto Server  ; nicht verstanden; auf nchstes Kommando warten
Srv784_1A87:  ; Hier nach Empfang von 02 1A 87 00 00 00 00 00 :
785        03 7F 1A 78 00 00 00 00  ; 7F 1A 78 = "kann noch nicht antworten"
785        10 16 5A 87 01 03 10 00  ; spaeter nachgelieferte Antwort
wcan 784 8 30 08 28 xx xx xx xx xx  ; der Client sollte irgendwann HIER weitermachen
785        21 FF 05 33 05 33 00 39
785        22 30 36 34 34 36 30 30
785        23 35 33 34 34 36 30 30
@goto Server  ; fertig mit diesem Parameter
Srv784_1802:  ; Hier nach Empfang von 04 18 02 FF 00 00 00 00 :
785        02 58 00 34 34 36 30 30
@goto Server  ; fertig mit ECU-ID 0x784 !


Srv788:  ; Simulation der ECU mit RX-ID 0x788 ============================
; Auch hier sind verschiedene Parameter abfragbar...
@if(Cmd==0x021A8700) goto Srv788_1A87
@if(Cmd==0x041802FF) goto Srv788_1802
@goto Server  ; nicht verstanden; auf nchstes Kommando warten
Srv788_1A87:  ; Hier nach Empfang von 02 1A 87 00 00 00 00 00 :
789        10 16 5A 87 01 91 00 14
wcan 788 8 30 08 28 xx xx xx xx xx
789        21 FF 05 39 05 42 11 39
789        22 30 36 32 36 30 31 32
789        23 30 39 00 00 00 00 00
@goto Server  ; fertig mit diesem Parameter
Srv788_1802:  ; Hier nach Empfang von 04 18 02 FF 00 00 00 00 :
789        02 58 00 00 00 00 00 00
@goto Server  ; fertig mit ECU-ID 0x788 !


Srv792:  ; Simulation der ECU mit RX-ID 0x792 ============================
; Auch hier sind verschiedene Parameter abfragbar...
@if(Cmd==0x021A8700) goto Srv792_1A87
@if(Cmd==0x041802FF) goto Srv792_1802
@goto Server  ; nicht verstanden; auf nchstes Kommando warten
Srv792_1A87:  ; Hier nach Empfang von 02 1A 87 00 00 00 00 00 :
793        10 16 5A 87 01 48 01 01
wcan 792 8 30 08 28 xx xx xx xx xx
793        21 FF 05 12 05 43 00 39
793        22 30 36 35 34 30 30 33
793        23 34 35 00 00 00 00 00
@goto Server  ; fertig mit diesem Parameter
Srv792_1802:  ; Hier nach Empfang von 04 18 02 FF 00 00 00 00 :
793        02 58 00 00 00 00 00 00
@goto Server  ; fertig mit ECU-ID 0x792 !


@stop

wcan 5FF 4 XX XX XX XX


; <EOF>
