; MktStandardSignals1.cts = Testprogramm zum Senden der "MKT-Standard-Testsignale"
;          Diente urspruenglich fuer "UPT"-Entwicklung  mit CAN-Logger" ,
;          spter aber auch fr andere Standard-Testflle - sogar CAN FD.
;
;  Autor:  Wolfgang Bscher
;  Stand:  2019-08-29 (ISO 8601, YYYY-MM-DD)
;
;  Ablage:  C:\CBproj\CanTest\programs\MktStandardSignals1.cts (CAN-Tester-Script).
;  Passende Signaldefinitionen  : c:\cbproj\CanTest\programs\MktStandardSignals1.dbc
;                    Kopie davon: c:\cbproj\UptWin1\programs\MktStandardSignals1.dbc
;  Testapplikation fuer MKT-View: UptWin1\programs\Log_tst1.cvt .
;  Testsignale als VECTOR-Logfile: UptWin1\programs\MktStandardSignals1.asc .
;  Weitere Info: Siehe   C:\CBprog\UptWin1\testfiles\readme_candb_terminal_tests.txt
; Lauffaehig mit WoBu's CAN-Tester fuer WINDOZE (ab 2013-12-09, wegen floating point).
; DIESE DATEI IST TEIL DES CAN-TESTER-INSTALLATIONSARCHIVS (und damit "public") !



Neustart:

;----------------------------------------------------------------------------
StandardTest1:
OpenWindow( "MKT-Standard-Testsignale #1", w=410, h=270 )
 ClearScreen() : SetFont("Arial",20,1) : print("Sende Standard-Test-Signale")
 SetFont("Arial",8,0) : MoveTo(20,40)
 print "Signaldefinitionen: c:\cbproj\CanTest1\programs\MktStandardSignals1.dbc"
 SetFont("Courier New",9,0)
 print "CAN-IDs / Signale:"
 print "0x333.s: ThreeSines1, ThreeSines2, ThreeSines3"
 print "0x444.x: FourSines1,   ....      , FourSines4"
 SetFont("Arial",8,0) : print 
 print "Die im Moment GESENDETEN Signale haben einen sinusfrmigen Verlauf"
 print "mit unterschiedlichen Frequenzen und z.T. unterschiedlichen Amplituden ."
 print
 print "Mit einem zweiten PC kann der Verlauf dieser Signale angezeigt werden."
 print "Dazu auf dem zweiten PC auf \"Empfang\" klicken, bevor die CAN-Verbindung"
 print "hergestellt wird (sonst gibt's ble CAN-ID-Kollisionen / Protokollfehler)."
 SetButton( 1, "&Hilfe",   goto Hilfe   )
 SetButton( 2, "&Beenden", goto Beenden )
 SetButton( 3, "&Empfang", CloseWindow():goto Receive )

 @N=0 
 @tx_interval=0.001   ; X seconds per CAN-TX-commandline
OnError goto Verflixt ; define error handler (jump if "something" goes wrong)

TestLoop1:  ; Send MKT-Standard-Test-Signals #1
 #1 0x333.s (isin(N*9)).w (0.9*isin(N*8)).w (0.8*isin(N*7)).w     ; "ThreeSines" (3*16 bit, lower frequencies) on "CAN1"
 #2 0x333.s (isin(N*17)).w (0.9*isin(N*13)).w (0.8*isin(N*11)).w  ; "ThreeSines" (3*16 bit, higher frequencies) on "CAN2"
 0x444.x (isin(N*0.1)).w (0.9*isin(N*0.2)).w (0.8*isin(N*0.3)).w (0.7*isin(N*0.4)).w  ; "FourSines" (4*16 bit)
 0x12345678.x  (N/9).w (N/8).w (N/7).w (N/6).w ; message "Thermo_Sensor"
 0x334.s (1<<N).il (1<<N).il  ; "U32Test" and "S32Test" (2*32 bit, unsigned+signed)
 0x335   (N*0.123).if (N*0.123).mf ; send "IntelFloat1" and "MotorolaFloat1" (details further below)
@N=N+1:@goto TestLoop1 ; rem N may also step by 31 for "very fast sinewaves" 


TestLoop2:  ; Modifizierte CAN-Identifier fuer Hau-Ruck-Test "zwischendurch"
 0x0E1 (isin(N*3)).w (0.9*isin(N*2.1)).w (0.8*isin(N*1.7)).w  ; "ThreeSines" (3*16 bit)
 0x0E3 (isin(N*0.1)).w (0.9*isin(N*0.2)).w (0.8*isin(N*0.3)).w (0.7*isin(N*0.4)).w  ; "FourSines" (4*16 bit)
 0x12345678.x  (N/9).w (N/8).w (N/7).w (N/6).w ; message "Thermo_Sensor"
@N=N+1:@goto TestLoop2

TestLoop3:  ; Modifizierte CAN-Identifier fuer Audio-Test (audio_t.cvt)
 0x334.s (N&15).il (N).il  ; "U32Test" and "S32Test" (2*32 bit, unsigned+signed)
@N=N+1:@goto TestLoop3 ; rem may step by 31 for "very fast sinewaves" 
 0x334.s 1.il 0.il  ; "U32Test" = 1  -> Wuff, Klff, Muh, Miau, Blk ...
 0x334.s 2.il 0.il
 0x334.s 3.il 0.il
 0x334.s 4.il 0.il
 0x334.s 7.il 0.il  ; "U32Test" = 7  -> STOP audio output
 0x334.s 0.il 0.il  ; "U32Test" = 0  -> continue current playback, then stop



@tx_interval=0.0001   ; X seconds per CAN-TX-commandline

TestLoop4: ; Test signal for UptWin1/programs/script_demos/Diagrams.cvt, "Fast sampling diagram":
  0x00CC 0x01  ; "Klick" (Strom durch den Pieper AN, Basis vom NPN-Transi HIGH)
  delay(0.003) ; Pulse length for the beeper output, not very accurate on a Windoze PC
  0x00CC 0x00  ; "Klack" (Strom durch den Pieper AUS, Basis vom NPN-Transi LOW)
  0x333.s (isin(time)).w (0.9*isin(time/3)).w (0.8*isin(time/4)).w  ; "ThreeSines" (3*16 bit, higher frequencies)
  delay(0.02) ; pause between two pulses (or "trigger events" for script_demos/Diagrams.cvt)
@N=N+1:@goto TestLoop4

TestLoop5: ; Test for CAN FD (anno 2020, for the planned 'MKT-View V' 
  0x333 FDF 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F 20 21 22 23 24 25 26 27 28 29 2A 2B 2C 2D 2E 2F 30 31 32 33 34 35 36 37 38 39 3A 3B 3C 3D 3E 3F 40
  ; 2020-01-20 : Transmission of large frames WITHOUT BRS ("FDF" only) was ok.
  ;              RECEPTION of large frames WITH OR WITHOUT BRS was also ok.
  ;              Transmission of large frames WITH BRS (like the one below)
  ;              resulted in an ERROR FRAME, and after that, the bus was dead
  ;              until executing 'Tools'..'Reset CAN Hardware' in the tester !
  0x333 BRS 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F 20 21 22 23 24 25 26 27 28 29 2A 2B 2C 2D 2E 2F 30 31 32 33 34 35 36 37 38 39 3A 3B 3C 3D 3E 3F 40
  0x444.x BRS 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F 20 21 22 23 24 25 26 27 28 29 2A 2B 2C 2D

  delay(0.02) ; pause between two large FD frames
@N=N+1:@goto TestLoop5




Beenden:    ; Fenster schliessen "und Tschss"
 CloseWindow()
stop

Receive:    ; Watch/Plot-Fenster des CAN-Testers ffnen um Testsignale anzuzeigen
 CloseWindow()      ; User-Fenster schliessen um Platz zu schaffen
 ; Prepare SCOPE/Plotter to show values from PDO :
 @scope.show(2)     ; REM show channel definition tab in the scope window
 @scope.timing=0.01 ; REM set scope sampling interval (seconds)
 ; REM scope.ch[x]={ Name, Expression, ScaleMin, ScaleMax }
 @scope.ch[0]={"ThreeSines1", canrx(0x333, 0,I16), -32768, 32768 }
 @scope.ch[1]={"ThreeSines2", canrx(0x333,16,I16), -32768, 32768 }
 @scope.ch[2]={"ThreeSines3", canrx(0x333,32,I16), -32768, 32768 }
 @scope.ch[3]={"FourSines1",  canrx(0x444, 0,I16), -32768, 32768 }
 @scope.ch[4]={"FourSines2",  canrx(0x444,16,I16), -32768, 32768 }
 @scope.ch[5]={"FourSines3",  canrx(0x444,32,I16), -32768, 32768 }
 @scope.ch[6]={"FourSines4",  canrx(0x444,48,I16), -32768, 32768 }
 @scope.show(1) ; REM open the "plotter" tab in the scope window 
 @scope.run     ; REM start scrolling the scope/plot window
 print "Kommandoprogramm mit F9 neu starten !"
stop


Hilfe:      ; Hilfe-Fenster anzeigen
OpenWindow( "MKT-Standard-Testsignale #1", w=400, h=250 )
 ClearScreen() : SetFont("Arial",20,1) : print("MKT-Standard-Test-Signale")
 SetFont("Arial",8,0) : MoveTo(20,40)
 print "Dieses Programm fr WoBu's CAN-Tester sendet einige CAN-Telegramme"
 print "mit leicht wiederzuerkennenden Signalen (Sinuskurven etc), mit dem"
 print "im November 2005 einige Funktionen des CAN-Loggers getestet wurden."
 print "Es eignet sich allerdings auch fr andere Tests mit dem CAN-Bus."
 print 
 print "Die Signaldefinitionen sind in einer CANdb-Datei beschrieben, die"
 print "beim Autor (WoBu) erhltlich ist (MktStandardSignals1.dbc) ."
 print 
 print "Klicken Sie auf \"OK\", um zum Test zurckzukehren."
 SetButton( 1, "&Ok",  CloseWindow() : goto StandardTest1 )
Hilfe1:
 goto Hilfe1   ; warten auf Event (Button)

;--------- Bei Fehlern... ----------------------------------------------------------
Verflixt:
 OpenWindow( "CAN-Test : FEHLER ! ",w=400,h=200,bc=red)
 SetFont("Arial",8) : MoveTo(8,4) 
 print( "Fehlercode %ld in Programmzeile %ld", ErrorInfo.code, ErrorInfo.line )
 print( ErrorInfo.text )
 SetFont("Arial",11,2) : MoveTo(8,40) 
 print "- CAN-Baudrate berprfen (momentan %ld kBit/sec)",can.baudrate
 print "- die verdammten Kabel und Abschlusswiderstnde berprfen"
 print "- eventuell vorhandene DIP-Schalter richtig einstellen"
 SetButton( 1,"&Nochmal versuchen",  goto Neustart )
 SetButton( 2,"&Abbrechen",  goto Abbruch )
Fehlerschleife:
goto Fehlerschleife
Abbruch:  ; ABBRUCH im Fehlerfall, ohne nochmaligen CAN-Sendeversuch !
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmabbruch - Neustart mit F9 !"
@stop


;-----------------------------------------------------------------------------
; Im April 2004 tauchte der Wunsch auf, auch GEMULTIPLEXTE Signale zu loggen
; und per Logfile-Konverter zu DECODIEREN. Zum Testen dienten:
;   - die Terminal-Applikation c:\cbproj\UptWin1\programs\Log_tst1.cvt
;   - die CAN-Datenbanken      c:\cbproj\UptWin1\programs\muxtest_bus1.dbc
;                          und c:\cbproj\UptWin1\programs\muxtest_bus2.dbc
;   - die CAN-Logger-Config    c:\cbproj\CanLoggerUtility\Logger_muxtest.clc
;   - Datei fuer CAN-TESTER:   c:\cbproj\UptWin1\testfiles\CanLogTs.TXT
; Hier werden zwei verschiedene Messages auf zwei verschiedenen Bussen getestet.
; Um die gemultiplexten Signale nach dem Decodieren voneinander unterscheiden
; zu koennen, wird hier fuer jedes Signal eine INDIVIDUELLE Funktion erzeugt :
MuxLog:
 0x32345678 0x30 (N*16384).ml 0x00 0x00 0x00  ; M1x8_M32_m3  ( 29 bit, mux#3, BUS 1 )
 0x32345679 0x30 (N*N*256).ml 0x00 0x00 0x00  ; M1x9_M32_m3  ( 29 bit, mux#3, BUS 2 )
 0x32345678 0x20 ((32768+isin(N*3))*32).ml    ; M1x8_M32_m2  ( 29 bit, mux#2, BUS 1 )
 0x32345679 0x20 ((32768+isin(N*4))*32).ml    ; M1x9_M32_m2  ( 29 bit, mux#2, BUS 2 )
 0x32345678 0x10 ((32768+isin(N*5))*16).ml    ; M1x8_M32_m1  ( 29 bit, mux#1, BUS 1 )
 0x32345679 0x10 ((32768+isin(N*6))*16).ml    ; M1x9_M32_m1  ( 29 bit, mux#1, BUS 2 )
 0x32345678 0x00 ((32768+isin(N*5))*N).ml     ; M1x8_M32_m0  ( 29 bit, mux#0, BUS 1 )
 0x32345679 0x00 ((32768+isin(N*6))*N).ml     ; M1x9_M32_m0  ( 29 bit, mux#0, BUS 2 )
@N=(N+10)&0x07FF:@goto MuxLog

; Test SIGNED / UNSIGNED mit den Signalen "S32Test" und "U32Test" :
 0x334.s 0x00000000.il 0x00000000.il  ; "U32Test" and "S32Test" = 0 (2*32 bit, unsigned+signed)
 0x334.s 0x00000001.il 0x00000001.il  ; "U32Test"=+1,           "S32Test"=+1
 0x334.s 0x80000000.il 0x80000000.il  ; "U32Test"=+2147483638,  "S32Test"=-2147483638
 0x334.s 0xFFFFFFFF.il 0xFFFFFFFF.il  ; "U32Test"=+4294967295,  "S32Test"=-1


;-----------------------------------------------------------------------------
; Im Oktober 2009 traten bei Volke Probleme mit 32-Bit-Floats auf,
; wobei allerdings nicht klar war, ob dies INTEL oder MOTOROLA-Byte-Order war.
; Um dies zu testen, diente damals die Display-Applikation 
;  \cbproj\UptWin1\programs\float_t.cvt ; Signale aus Float_and_Double.dbc :
; Spter (2013-12-09) kam fr Opel/GM die Notwndigkeit auf,
;  auch 'Motorola-Floats' (mit 32 bit) in der UPT-Firmware zu untersttzen.
;  Der CAN-Tester, dieses Script, und auch MktStandardSignals1.dbc
;  wurden dazu entsprechend erweitert. Message-ID 0x335, "FloatTestMsg",
;  enthlt zu dem Zweck in Bits 0..31 einen INTEL-FLOAT-Wert ("IntelFloat1");
;  in Bits 32..63 (nach Intel-Zhlweise!) steckt ein MOTOROLA-FLOAT ("MotorolaFloat1").
;  Zu Testen per MKT-View II,III mit cbproj/UptWin1/programs/MKTview2/MV2_Demo.CVT :
0x335 (#123.456).if  (#123.456).mf  ; send "IntelFloat1" and "MotorolaFloat1" 
0x335 0x42892C00.il  0x42892C00.ml  ; -> Float1_I= 68.58594,  Float1_M= 68.58594
0x335 (#68.58594).if (#68.58594).mf ; -> should give the same result (on the CAN bus)

@N = 0
@N = -1234.5
TestLoop5:  ; Send FLOATING POINT signals, "Intel" and "Motorola" byte order
 0x335 (0.111*N).if (0.111*N).mf    ; send "IntelFloat1" and "MotorolaFloat1" (details further below)
@N=N+1:@goto TestLoop5 ; rem N may also step by 31 for "very fast sinewaves" 



; Signal "Double1" auf CAN-ID #0, auf dem CAN-Bus(!) mit 64 Bit bertragen,
; kann aber im Display (noch) nicht verarbeitet werden !
0x000 0.il  0.il  ; ->  "Double1" = 0000.00

; Signal "Float1_I" ist 32-bit FLOAT mit INTEL-Byte-Order.
; Signal "Float1_M" ist 32-bit FLOAT mit MOTOROLA-Byte-Order.
; BEIDE STECKEN IN DER GLEICHEN CAN-MESSAGE (was etwas Probleme
;   mit Kvaser's CANdb-Editor verursachte..)
; 
0x001 0.il  0.ml  ; -> Float1_I= 0.0,  Float1_M= 0.0
 ; Beispiel von Volke (aus Email von Herrn Antemann) :
0x001 0x42892C00.il  0x42892C00.ml  ; -> Float1_I= 68.586,  Float1_M= 68.586
 ; Noch ein Beispiel, aus http://de.wikipedia.org/wiki/IEEE_754 , 
 ; "Die Zahl 18.4 soll in eine Gleitkommazahl umgewandelt werden"...
 ; 1 Bit Vorzeichen + 8 Bit Exponent + 23 Bit Mantisse
 ; 0 10000011 00100110011001100110011 (binr) -> 
 ;    die Vorkomma-Eins wird als Hidden Bit weg gelassen; 
 ;    da dort immer eine 1 steht, braucht man diese nicht zu speichern.
 ; Der obige binre Rattenschwanz in hexadezimaler Form:
 ; 0100 0001 1001 0011 0011 0011 0011 0011 (noch immer binr) -> 
 ;  4    1    9    3    3    3    3    3
0x001 0x41933333.il 0x41933333.ml  ; -> Float1_I= 18.400,  Float1_M= 18.400
 
; Signal "MotFloat0" und "MotFloat1" sind BEIDES 32-Bit-Floats
; mit Motorola-Byte-Order, die beide im gleichen CAN-Telegramm stecken:
0x002 0x42892C00.ml 0x42892C00.ml  ; -> MotFloat0= 68.586,  MotFloat1= 68.586
0x002 0x41933333.ml 0x41933333.ml  ; -> MotFloat0= 18.400,  MotFloat1= 18.400
0x002 0xC1933333.ml 0xC1933333.ml  ; -> MotFloat0=-18.400,  MotFloat1=-18.400


; Rauschhnliche Zufallssignale fr CCP-Test von Agostec, siehe Email 2011-08-11
; Multiplexer in Byte[0], 8 bit, Mux-Werte aber nur 16 bis 20 (?)
@tx_interval=0.0005    ; "Volldampf!" (0.5 ms per CAN-transmission)
CcpLoop:
 0x210 (16+(time&7)).b (time/17).b (time/7).i time.l // noisy, almost random, data field
@goto CcpLoop



; LPC4357
0x000    11 22 33 44 55 66 77 88
0x0000.x 11 22 33 44 55 66 77 88

; Seit 08/2019 knnen mit Kvaser-Interfaces auch CAN-FD-Frames gesendet werden,
; ferner gibt's Support fr Interfaces mit MEHREREN Kanlen. Die Bus-Nummer
; kann auch beim SENDEN per '#1' (fr "CAN1") bzw. '#2' (fr CAN2) definiert werden.
; Werden z.B. beim "Kvaser Hybrid 2xCAN/LIN" beide Kanle miteinander verbunden,
; und beide Busse mit der gleichen Bitrate betrieben, sollten auf Kanal #1 gesendete
; Frames auf Kanal #2 wieder 'reinpurzeln, und umgekehrt :
#1 0x12345 11 22 33 44 55 66 77 88 // transmit a short message on the FIRST CAN channel
#2 0x12345 11 22 33 44 55 66 77 88 // transmit a short message on the SECOND CAN channel
; Datenfeld mit mehr als 8 Bytes werden automatisch zur nchstgreren 'FD'-Frame erweitert,
; wobei nur 1..8, 12, 16, 20, 24, 32, 48 oder 64 Bytes als "DLC" codiert werden knnen:
#1 0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F 20 21 22 23 24 25 26 27 28  // transmit a long message on CAN1
#2 0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F 20 21 22 23 24 25 26 27 28  // transmit a long message on CAN2
0x12345 01 02 03 04 05 06 07 08                                  ; -> 8-byte data field
0x12345 01 02 03 04 05 06 07 08 09                               ; -> 12-byte data field ! (3 zero-bytes padded)
0x12345 01 02 03 04 05 06 07 08 09 0A                            ; -> 12-byte data field ! (2 zero-bytes padded)
0x12345 01 02 03 04 05 06 07 08 09 0A 0B                         ; -> 12-byte data field ! (1 zero-byte padded)
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C                      ; -> 12-byte data field
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D                   ; -> 16-byte data field !
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E                ; -> 16-byte data field !
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F             ; -> 16-byte data field !  
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10          ; -> 16-byte data field
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11       ; -> 20-byte data field ! (3 zero-bytes padded)
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12
0x12345 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13
print( "Error Frames on CAN1 : ", can[0].nErrorFrames );
print( "Error Frames on CAN2 : ", can[1].nErrorFrames );


0x301 r XX XX XX XX XX XX XX XX
