; Sahm6TastenTest.TXT:   Testprogramm zum Ansteuern der "SAHM-TASTATUR".
;  Lauffhig mit CAN TESTER FR WINDOWS - Start mit  F9  !
;  Basiert auf "KEYP_SAH.TXT" (vom CAN-Tester fr DOS) .
;  Ablage: <WoBu3>C:\cbproj\CanTest\Programs\Sahm6TastenTest.TXT
;  Stand:  2006-10-12    Autor: W.Buescher
; Telegramme: PDO $200+x: 1.Word=LEDs        2.Word=Hintergrund 3.Word=DigOut
;             PDO $180+x: 1.Word=Tasten-Bits 2.Word=Joystick    3.Word=DigIn
; CAN-Baudrate: Meistens 500, manchmal auch 250 kBit/sec ! !

OnError goto Verflixt ; Sprung falls irgendwas schiefgeht

ClearVars()     ; alte Variableninhalte lschen
; Identifier der verwendeten CAN-Telegramme definieren .
;  Bei SAHM war dies eigentlich immer 0x214 (RPDO) und 0x194(TPDO) .
@D = $14  ; CANopen-hnlicher "Node-ID"
@R = $200+D ; RPDO1 (aus Sicht der Tastatur), SAHM-T6:$214
@T = $180+D ; TPDO1 (aus Sicht der Tastatur), SAHM-T6:$194

@tx_interval=0.01  // set TX interval, also limits execution speed: SECONDS per line

Neustart:
OpenWindow("SAHM-Tastatur-Test \"6 Tasten\"",w=500,h=333)
SetFont("Arial",20):ClearScreen()
$000 01 14     ; "Start Sendeprotokoll" (SAHM-Slang)
@delay(1)      ; Verzoegerung seit 2006-04 in SEKUNDEN (SI-Einheit)

ClearScreen() 
@LedTestBits = 0 ; keine extra gesetzten LEDs
SetButton(1,"&Neustart",goto Neustart)
SetButton(2,"&Beenden", goto Beenden)
SetButton(3,"&Alle LEDs an/aus", @LedTestBits=LedTestBits^0xFFFF)
SetFont("Arial",8):MoveTo(0,10)
print( "CAN-Baudrate = %ld kBit/sec",can.baudrate ) ; 100 oder 250 kBit/sec ?
SetFont("Arial",15,7):MoveTo(10,130)
print( " Gedrckte Tasten mssen HELL aufleuchten ! " )
SetFont("Arial",12,0):MoveTo(30,170)
print( "Dieser Test verbindet die Tasten per CAN-Bus mit den LEDs." )
print( "Vor dem Umstecken der CAN-Kabel unbedingt erst den Test " )
print( "beenden (B), und erst nach Anschluss der nchsten Tastatur" )
print( "den Test wieder starten (F9) .. sonst gib't CAN-Trouble !" )
print( "Solange der Test NICHT luft, blinken die \"O\"- und \"I\"-Tasten ." )


$000 01 14       ; "Start Sendeprotokoll" (SAHM-Slang)

Loop1: ; Schleife 1 : fuer BUCHER-Tastatur.
       ; Funktion: Hintergrundhelligkeit aendert sich staendig,
       ; beim Druecken einer Taste muss diese hell aufleuchten.
 @KeyMatrixBits = canrx(T,0,I16,0)  ; 16-bit Tastenzustnde lesen
 @JoystickBits  = canrx(T,16,I16,0) ; 16-bit Joystick-Kontakte
 @DigitalInputs = canrx(T,32,I16,0) ; 16-bit digitale Eingnge
 (R) (KeyMatrixBits|LedTestBits).w (H/4).w $0000.w  ; PDO-Telegramm senden
 @H=(H+1)&63       ; Hintergrundbeleuchtung aendern
 SetFont("Courier New",26):MoveTo(0,40)
 print "Tast.: %16b",KeyMatrixBits )  ; Matrixbits als Binrzahl
 print "LEDs : %16b",LedTestBits   )  ; LED-Test-Muster
@goto Loop1


;--------- Planmaessiges Ende des Tests... ----------------------
Beenden:
CloseWindow()
print "Programmende - Neustart mit F9"
stop

;--------- Bei Fehlern... ---------------------------------------
Verflixt:
 OpenWindow( "CAN-Test : FEHLER ! ",w=400,h=200,bc=red)
 SetFont("Arial",8) : MoveTo(8,4) 
 print( "Fehlercode %ld in Programmzeile %ld", ErrorInfo.code, ErrorInfo.line )
 print( ErrorInfo.text )
 SetFont("Arial",11,2) : MoveTo(8,40) 
 print "- CAN-Baudrate berprfen (momentan %ld kBit/sec)",can.baudrate
 print "- Knotennummer berprfen (momentan #%ld )",sdo.node
 print "- die verdammten Kabel berprfen"
 print "- die DIP-Schalter richtig einstellen"
 SetButton( 1,"&Nochmal versuchen",  goto Neustart )
 SetButton( 2,"&Abbrechen",  goto Abbruch )
Fehlerschleife:
goto Fehlerschleife
Abbruch:  ; ABBRUCH im Fehlerfall, ohne nochmaligen CAN-Sendeversuch !
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmabbruch - Neustart mit F9 !"
@stop


; EOF